#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

int main(int argc, char * argv[]) {

	int fd[2];
	pipe(fd);
	switch(fork()) {
		case 0:
			dup2(fd[1], 1);
			close(fd[0]);
			execlp("ls", "ls", NULL);
			exit(-1);
		case -1:
			perror("fork1");
			exit(-1);
		default:
			break;
	}
	switch(fork()) {
		case 0:
			dup2(fd[0], 0);
			close(fd[1]);
			execlp("sort", "sort", "-r", NULL);
		case -1:
			perror("fork1");
			exit(-1);
		default:
			break;
	}
	close(fd[0]);
	close(fd[1]);
	int status;
	wait(&status);
	wait(&status);
}
