#include <stdio.h>
#include <signal.h>
#include <poll.h>

void ctrlc_handler(int sig) {
	printf("got ctrl-c\n");
}

void term_handler(int sig) {
	printf("got term, but I'm not dying\n");
}

int main(int argc, char *argv[]) {
	signal(SIGINT, ctrlc_handler);
	signal(SIGTERM, term_handler);
	while (1) {
		poll(NULL, 0, 1000);
		printf("tick\n");
	}
}
